-----------------------------------------------------------------
----------------------- SOME COMMENTS BEFORE WE BEGIN -------------------
-----------------------------------------------------------------
--[[
This is insAddonTest2.lua by instant
* All the commenting is done in insAddonTest1 
* This "addon" does very little alone. 
]]--


if insADD2 == nil then insADD2 = {} end
 
insADD2.name = "insAddonTest2" -- this will work
insADD2.version = 0.2 -- We include a version number
insADD2.title = "InsADD2 Options"

local counter=0
local CATEGORY_INSADDTEXT = "InsADD2"

  local colors={}
  local val = "|c000000"
  table.insert(colors, val)
  local val = "|c00FF00"
  table.insert(colors, val)
  local val = "|c0000FF"
  table.insert(colors, val)
  local val = "|cFF0000"
  table.insert(colors, val)
  local val = "|cFF00FF"
  table.insert(colors, val)
  local val = "|cFFFF00"
  table.insert(colors, val)
  local val = "|c00FFFF"
  table.insert(colors, val)
  local val = "|c100010"
  table.insert(colors, val)
  local val = "|c001000"
  table.insert(colors, val)
  local val = "|c5000C0"
  table.insert(colors, val)
  local val = "|cC0C000"
  table.insert(colors, val)
  local val = "|cA0B000"
  table.insert(colors, val)
  local val = "|c00E0F0"
  table.insert(colors, val)
  local val = "|cD05010"
  table.insert(colors, val)
  local val = "|cFA5500"
  table.insert(colors, val)
  local val = "|c00CCC0"
  table.insert(colors, val)
  local val = "|cDDD000"
  table.insert(colors, val)
  local val = "|c006660"
  table.insert(colors, val)
  local val = "|c055500"
  table.insert(colors, val)

--------------------------------------------------------------------
---  Change function
--       input: nothing
--  The purpose of this function is to showcase which variables
--  "Leak" outside an addon.
-- This is a GLOBAL function, accessible to any addon 
-- Which means they can also redefine its purpose.
--------------------------------------------------------------------
function insADD2.change()
   d("Change is coming.")
   
   d("Lets see if we can print the variables from insADD1")
   -- if we do not use a tostring, the addon will fail because some of
   -- the variables we are referencing do not exist outside of insAddonTest1
   d("insADD1var01: "..tostring(insADD1var01)) -- this is a global from insAddonTest1.lua
   d("insADD1var02: "..tostring(insADD1var02))
   d("insADD1var03: "..tostring(insADD1var03))
   d("insADD1var04: "..tostring(insADD1var04)) -- this is a global from  insAddonTest1.lua:Initialize()
   d("insADD1var05: "..tostring(insADD1var05))
   d("insADD1var06: "..tostring(insADD1var06))
   d("insADD1var07: "..tostring(insADD1var07)) -- this is a global after insAddonTest1.lua:test() is run
   d("insADD1var08: "..tostring(insADD1var08)) -- this is a global after insAddonTest1.lua:test() is run
   d("insADD1var09: "..tostring(insADD1var09))
   d("insADD1var10: "..tostring(insADD1var10))
   d("insADD1var11: "..tostring(insADD1var11))
   
   insADD1var01 = "insADD1var01 global was changed in insAddonTest2.lua:insAdd2.change()"
   insADD1var04 = "insADD1var01 global was changed in insAddonTest2.lua:insAdd2.change()"
   insADD1var07 = "insADD1var01 global was changed in insAddonTest2.lua:insAdd2.change()"
   insADD1var08 = "insADD1var01 global was changed in insAddonTest2.lua:insAdd2.change()"
end


function insADD2.col(text)  
  local outputs = " "
  maxcol = #colors
  curcol = 1
  local letter
  
	for i = 1, string.len(text) do 
			letter =string.sub(text, i, i)
			letter = colors[curcol]..letter
			--d(letter)
			outputs = outputs..letter
			curcol = curcol + 1
			if curcol == maxcol then curcol = 1 end
	end
	--d(outputs)
	StartChatInput(outputs,nil,nil)
end

--------------------------------------------------------------------
---  commandHandler function
--       input: text (Commands)
--------------------------------------------------------------------
local function commandHandler(text)
  local input = string.lower(text)
  local com = {}
  local index = 1
  if text~=nil then
    for value in string.gmatch(input,"%w+") do  
        com[index] = value
        index = index + 1
    end
  end
  if com[1]=="change" then
    insADD2.change()
  elseif com[1]=="gui" then
    guisetup()
  else
    d("No Arguments from me!")
    d("Do we need any commands in AddonTest2?")
    d("try: change ")
  end
end -- We end our function

--------------------------------------------------------------------
---  insADD2.Initialize function
--       input: eventCode, addOnName
--------------------------------------------------------------------
local function Initialize( eventCode, addOnName )
     if ( addOnName ~= insADD2.name ) then return end

     insADD2.vars		= {
											["key1"] = "This is from insAddonTest2.lua",
											["key2"] = {
																	["key2key1"] = "This is from insAddonTest2.lua", 
																}}
		insADD2.SV = ZO_SavedVars:New("insADD2_SV" , 1 , nil , insADD2.vars, nil )            
     
		zo_callLater(function() d("insADD2 has loaded..: The addonname was: "..addOnName) end, 4000)	    

		-- we unregister for the event as the addon is loaded.
		EVENT_MANAGER:UnregisterForEvent("insADD2",EVENT_ADD_ON_LOADED)

    -- we register our slash command
    SLASH_COMMANDS["/addtest2"] = commandHandler
end  -- end of insADD2.Initialize function

-- We register an event to initialize the addon. 
EVENT_MANAGER:RegisterForEvent("insADD2",EVENT_ADD_ON_LOADED,Initialize)



